<?php
class CurrentConditionDisplay implements Observer, DisplayElement {
    private $wheatherData;
    private $temperature;
    private $humidity;

    public function __construct(Subject $wheatherData) {
        $this->wheatherData = $wheatherData;
        $this->wheatherData->registerObserver($this);
    }

    public function update() {
        $this->temperature = $this->wheatherData->getTemperature();
        $this->humidity = $this->wheatherData->getHumidity();
        $this->display();
    }

    public function display() {
        echo "Current conditions:\n";
        echo $this->temperature . "F degrees and\n";
        echo $this->humidity . "% humidity.\n\n";
    }
}
