<?php
class ForecastDisplay implements Observer, DisplayElement {
    private $wheatherData;
    private $currentPressure = 29.92;
    private $lastPressure;

    public function __construct(Subject $wheatherData) {
        $this->wheatherData = $wheatherData;
        $this->wheatherData->registerObserver($this);
    }

    public function update() {
        $this->lastPressure = $this->currentPressure;
        $this->currentPressure = $this->wheatherData->getPressure();
        $this->display();
    }

    public function display() {
        echo "Forecast: ";
        if( $this->currentPressure > $this->lastPressure ) {
            echo "Improving weather on the way!\n\n";
        } elseif( $this->currentPressure == $this->lastPressure) {
            echo "More of the same\n\n";
		} elseif( $this->currentPressure < $this->lastPressure) {
			echo "Watch out for cooler, rainy weather\n\n";
		}
    }
}
