<?php
class StatisticsDisplay implements Observer, DisplayElement {
    private $wheatherData;
    private $minTemp = 0;
    private $maxTemp = 200;
    private $tempSum = 0;
    private $numReadings;

    public function __construct(Subject $wheatherData) {
        $this->wheatherData = $wheatherData;
        $this->wheatherData->registerObserver($this);
    }

    public function update() {
        $temperature = $this->wheatherData->getTemperature();
        $this->tempSum += $temperature;
        $this->numReadings++;
        
        if( $temperature > $this->maxTemp) {
			$this->maxTemp = $temperature;
		}

		if( $temperature < $this->minTemp) {
			$this->minTemp = $temperature;
		}
        
        $this->display();
    }

    public function display() {
        echo "Avg/Max/Min temperature = " . ($this->tempSum / $this->numReadings) . "/" . $this->maxTemp . "/" . $this->minTemp . "\n\n";
    }
}
